Backend API
<dx-polar-chart
id="radarChart"
[dataSource]="temperaturesData"
title="Average temperature in London"
>
<dxo-polar-chart-common-series-settings type="bar" [opacity]="0.75">
</dxo-polar-chart-common-series-settings>
<dxi-polar-chart-series valueField="day" name="Day" color="#fdff5e">
</dxi-polar-chart-series>
<dxi-polar-chart-series valueField="night" name="Night" color="#0f3b59">
</dxi-polar-chart-series>
<dxo-polar-chart-common-annotation-settings
type="text"
[opacity]="0.7"
[arrowLength]="0"
>
</dxo-polar-chart-common-annotation-settings>
<dxi-polar-chart-annotation text="WINTER" [angle]="45" [radius]="180">
</dxi-polar-chart-annotation>
<dxi-polar-chart-annotation text="SPRING" [angle]="135" [radius]="180">
</dxi-polar-chart-annotation>
<dxi-polar-chart-annotation text="SUMMER" [angle]="225" [radius]="180">
</dxi-polar-chart-annotation>
<dxi-polar-chart-annotation text="FALL" [angle]="315" [radius]="180">
</dxi-polar-chart-annotation>
<dxi-polar-chart-annotation
[argument]="maxDay.arg"
series="Day"
text="Highest temperature: {{ maxDay.day }} °C"
[opacity]="1"
[offsetX]="105"
[paddingTopBottom]="15"
[paddingLeftRight]="15"
>
</dxi-polar-chart-annotation>
<dxi-polar-chart-annotation
[argument]="minNight.arg"
series="Night"
text="Lowest temperature: {{ minNight.night }} °C"
[opacity]="1"
[offsetX]="105"
[paddingTopBottom]="15"
[paddingLeftRight]="15"
>
</dxi-polar-chart-annotation>
<dxo-polar-chart-argument-axis>
<dxi-polar-chart-strip
startValue="December"
endValue="February"
color="#0076d1"
>
</dxi-polar-chart-strip>
<dxi-polar-chart-strip startValue="March" endValue="May" color="#3ca3b0">
</dxi-polar-chart-strip>
<dxi-polar-chart-strip startValue="June" endValue="August" color="#3fbc1e">
</dxi-polar-chart-strip>
<dxi-polar-chart-strip
startValue="September"
endValue="November"
color="#f0bb00"
>
</dxi-polar-chart-strip>
</dxo-polar-chart-argument-axis>
<dxo-polar-chart-legend
horizontalAlignment="center"
verticalAlignment="bottom"
>
</dxo-polar-chart-legend>
</dx-polar-chart>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { DxPolarChartModule } from 'devextreme-angular';
import { Temperature, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxPolarChartModule,
],
})
export class AppComponent {
temperaturesData: Temperature[];
maxDay: Temperature;
minNight: Temperature;
constructor(service: Service) {
this.temperaturesData = service.getTemperaturesData();
this.maxDay = this.temperaturesData.reduce((prev, current) => (prev.day >= current.day ? prev : current));
this.minNight = this.temperaturesData.reduce((prev, current) => (prev.night <= current.night ? prev : current));
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #radarChart {
height: 600px;
}
import { Injectable } from '@angular/core';
export class Temperature {
arg: string;
day: number;
night: number;
}
const temperaturesData: Temperature[] = [{
arg: 'December',
day: 7,
night: 3,
}, {
arg: 'January',
day: 6,
night: 2,
}, {
arg: 'February',
day: 7,
night: 3,
}, {
arg: 'March',
day: 10,
night: 3,
}, {
arg: 'April',
day: 14,
night: 5,
}, {
arg: 'May',
day: 18,
night: 8,
}, {
arg: 'June',
day: 21,
night: 11,
}, {
arg: 'July',
day: 22,
night: 13,
}, {
arg: 'August',
day: 21,
night: 13,
}, {
arg: 'September',
day: 19,
night: 11,
}, {
arg: 'October',
day: 15,
night: 8,
}, {
arg: 'November',
day: 10,
night: 4,
}];
@Injectable()
export class Service {
getTemperaturesData(): Temperature[] {
return temperaturesData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.25',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.67',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.25/package.json',
'npm:devexpress-gantt@4.1.67/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.0.7"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
You can place annotations at specific coordinates or anchor them to PolarChart elements. This demo illustrates the following annotation placement methods:
- Angle and radius properties specify the position of annotations with season names.
- Annotations with temperatures are anchored to series points, and the offsetX, paddingTopBottom, and paddingLeftRight properties specify their position.
For more information on annotation settings, refer to the annotations[] help topic.

Backend API
import React from 'react';
import {
PolarChart,
CommonSeriesSettings,
Series,
CommonAnnotationSettings,
Annotation,
ArgumentAxis,
Strip,
Legend,
} from 'devextreme-react/polar-chart';
import { dataSource, maxDay, minNight } from './data.ts';
const maxTempText = `Highest temperature: ${maxDay.day} °C`;
const minTempText = `Lowest temperature: ${minNight.night} °C`;
function App() {
return (
<PolarChart
id="radarChart"
dataSource={dataSource}
title="Average temperature in London"
>
<CommonSeriesSettings
type="bar"
opacity={0.75}
/>
<Series
valueField="day"
name="Day"
color="#fdff5e"
/>
<Series
valueField="night"
name="Night"
color="#0f3b59"
/>
<CommonAnnotationSettings
opacity={0.7}
arrowLength={0}
type="text"
/>
<Annotation
angle={45}
radius={180}
text="WINTER"
/>
<Annotation
angle={135}
radius={180}
text="SPRING"
/>
<Annotation
angle={225}
radius={180}
text="SUMMER"
/>
<Annotation
angle={315}
radius={180}
text="FALL"
/>
<Annotation
argument={maxDay.arg}
opacity={1}
offsetX={105}
paddingTopBottom={15}
paddingLeftRight={15}
text={maxTempText}
series="Day"
/>
<Annotation
argument={minNight.arg}
opacity={1}
offsetX={105}
paddingTopBottom={15}
paddingLeftRight={15}
text={minTempText}
series="Night"
/>
<ArgumentAxis>
<Strip
startValue="December"
endValue="February"
color="#0076d1">
</Strip>
<Strip
startValue="March"
endValue="May"
color="#3ca3b0">
</Strip>
<Strip
startValue="June"
endValue="August"
color="#3fbc1e">
</Strip>
<Strip
startValue="September"
endValue="November"
color="#f0bb00">
</Strip>
</ArgumentAxis>
<Legend
horizontalAlignment="center"
verticalAlignment="bottom"
/>
</PolarChart>
);
}
export default App;
import React from 'react';
import {
PolarChart,
CommonSeriesSettings,
Series,
CommonAnnotationSettings,
Annotation,
ArgumentAxis,
Strip,
Legend,
} from 'devextreme-react/polar-chart';
import { dataSource, maxDay, minNight } from './data.js';
const maxTempText = `Highest temperature: ${maxDay.day} °C`;
const minTempText = `Lowest temperature: ${minNight.night} °C`;
function App() {
return (
<PolarChart
id="radarChart"
dataSource={dataSource}
title="Average temperature in London"
>
<CommonSeriesSettings
type="bar"
opacity={0.75}
/>
<Series
valueField="day"
name="Day"
color="#fdff5e"
/>
<Series
valueField="night"
name="Night"
color="#0f3b59"
/>
<CommonAnnotationSettings
opacity={0.7}
arrowLength={0}
type="text"
/>
<Annotation
angle={45}
radius={180}
text="WINTER"
/>
<Annotation
angle={135}
radius={180}
text="SPRING"
/>
<Annotation
angle={225}
radius={180}
text="SUMMER"
/>
<Annotation
angle={315}
radius={180}
text="FALL"
/>
<Annotation
argument={maxDay.arg}
opacity={1}
offsetX={105}
paddingTopBottom={15}
paddingLeftRight={15}
text={maxTempText}
series="Day"
/>
<Annotation
argument={minNight.arg}
opacity={1}
offsetX={105}
paddingTopBottom={15}
paddingLeftRight={15}
text={minTempText}
series="Night"
/>
<ArgumentAxis>
<Strip
startValue="December"
endValue="February"
color="#0076d1"
></Strip>
<Strip
startValue="March"
endValue="May"
color="#3ca3b0"
></Strip>
<Strip
startValue="June"
endValue="August"
color="#3fbc1e"
></Strip>
<Strip
startValue="September"
endValue="November"
color="#f0bb00"
></Strip>
</ArgumentAxis>
<Legend
horizontalAlignment="center"
verticalAlignment="bottom"
/>
</PolarChart>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const dataSource = [{
arg: 'December',
day: 7,
night: 3,
}, {
arg: 'January',
day: 6,
night: 2,
}, {
arg: 'February',
day: 7,
night: 3,
}, {
arg: 'March',
day: 10,
night: 3,
}, {
arg: 'April',
day: 14,
night: 5,
}, {
arg: 'May',
day: 18,
night: 8,
}, {
arg: 'June',
day: 21,
night: 11,
}, {
arg: 'July',
day: 22,
night: 13,
}, {
arg: 'August',
day: 21,
night: 13,
}, {
arg: 'September',
day: 19,
night: 11,
}, {
arg: 'October',
day: 15,
night: 8,
}, {
arg: 'November',
day: 10,
night: 4,
}];
export const maxDay = dataSource
.reduce((prev, current) => (prev.day >= current.day ? prev : current));
export const minNight = dataSource
.reduce((prev, current) => (prev.day <= current.day ? prev : current));
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.31/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.70/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const dataSource = [
{
arg: 'December',
day: 7,
night: 3,
},
{
arg: 'January',
day: 6,
night: 2,
},
{
arg: 'February',
day: 7,
night: 3,
},
{
arg: 'March',
day: 10,
night: 3,
},
{
arg: 'April',
day: 14,
night: 5,
},
{
arg: 'May',
day: 18,
night: 8,
},
{
arg: 'June',
day: 21,
night: 11,
},
{
arg: 'July',
day: 22,
night: 13,
},
{
arg: 'August',
day: 21,
night: 13,
},
{
arg: 'September',
day: 19,
night: 11,
},
{
arg: 'October',
day: 15,
night: 8,
},
{
arg: 'November',
day: 10,
night: 4,
},
];
export const maxDay = dataSource.reduce((prev, current) =>
prev.day >= current.day ? prev : current,
);
export const minNight = dataSource.reduce((prev, current) =>
prev.day <= current.day ? prev : current,
);
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#radarChart {
height: 600px;
}
You can place annotations at specific coordinates or anchor them to PolarChart elements. This demo illustrates the following annotation placement methods:
- Angle and radius properties specify the position of annotations with season names.
- Annotations with temperatures are anchored to series points, and the offsetX, paddingTopBottom, and paddingLeftRight properties specify their position.
For more information on annotation settings, refer to the annotations[] help topic.

DevExtreme v24.1 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

Vue Charts - Polar Chart with Annotations

Annotations are containers for images, text blocks, and custom content that display additional information about the visualized data.

To create annotations, populate the PolarChart's annotations array. Each object in the array configures an individual annotation. To specify settings for all annotations, use the commonAnnotationSettings object. Individual settings take precedence over common settings.

You can set each annotation's type property to "text", "image", or "custom". This demo shows only "text" annotations.

www.wikipedia.org
Backend API
<template> <DxPolarChart id="radarChart" :data-source="dataSource" title="Average temperature in London" > <DxCommonSeriesSettings :opacity="0.75" type="bar" /> <DxSeries value-field="day" name="Day" color="#fdff5e" /> <DxSeries value-field="night" name="Night" color="#0f3b59" /> <DxCommonAnnotationSettings :opacity="0.7" :arrow-length="0" type="text" /> <DxAnnotation :angle="45" :radius="180" text="WINTER" /> <DxAnnotation :angle="135" :radius="180" text="SPRING" /> <DxAnnotation :angle="225" :radius="180" text="SUMMER" /> <DxAnnotation :angle="315" :radius="180" text="FALL" /> <DxAnnotation :argument="maxDay.arg" :opacity="1" :offset-x="105" :padding-top-bottom="15" :padding-left-right="15" :text="maxTempText" series="Day" /> <DxAnnotation :argument="minNight.arg" :opacity="1" :offset-x="105" :padding-top-bottom="15" :padding-left-right="15" :text="minTempText" series="Night" /> <DxArgumentAxis> <DxStrip start-value="December" end-value="February" color="#0076d1" /> <DxStrip start-value="March" end-value="May" color="#3ca3b0" /> <DxStrip start-value="June" end-value="August" color="#3fbc1e" /> <DxStrip start-value="September" end-value="November" color="#f0bb00" /> </DxArgumentAxis> <DxLegend horizontal-alignment="center" vertical-alignment="bottom" /> </DxPolarChart> </template> <script setup lang="ts"> import { DxPolarChart, DxCommonSeriesSettings, DxSeries, DxCommonAnnotationSettings, DxAnnotation, DxArgumentAxis, DxStrip, DxLegend, } from 'devextreme-vue/polar-chart'; import { dataSource, maxDay, minNight } from './data.ts'; const maxTempText = `Highest temperature: ${maxDay.day} °C`; const minTempText = `Lowest temperature: ${minNight.night} °C`; </script> <style> #radarChart { height: 600px; } </style>
window.exports = window.exports || {}; window.config = { transpiler: 'plugin-babel', meta: { '*.vue': { loader: 'vue-loader', }, '*.ts': { loader: 'demo-ts-loader', }, '*.svg': { loader: 'svg-loader', }, 'devextreme/time_zone_utils.js': { 'esModule': true, }, 'devextreme/localization.js': { 'esModule': true, }, 'devextreme/viz/palette.js': { 'esModule': true, }, }, paths: { 'root:': '../../../../', 'npm:': 'https://unpkg.com/', }, map: { 'vue': 'npm:vue@3.2.47/dist/vue.esm-browser.js', 'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.1/index.js', 'demo-ts-loader': 'root:utils/demo-ts-loader.js', 'svg-loader': 'root:utils/svg-loader.js', 'mitt': 'npm:mitt/dist/mitt.umd.js', 'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js', 'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js', 'es6-object-assign': 'npm:es6-object-assign@1.1.0', 'devextreme': 'npm:devextreme@24.1.6/cjs', 'devextreme-vue': 'npm:devextreme-vue@24.1.6/cjs', 'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js', 'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js', 'devexpress-diagram': 'npm:devexpress-diagram@2.2.11/dist/dx-diagram.js', 'devexpress-gantt': 'npm:devexpress-gantt@4.1.56/dist/dx-gantt.js', '@devextreme/runtime': 'npm:@devextreme/runtime@3.0.13', 'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js', 'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js', 'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js', 'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js', 'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js', 'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js', 'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js', 'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js', 'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js', 'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js', // Prettier 'prettier/standalone': 'npm:prettier@2.8.8/standalone.js', 'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js', }, packages: { 'devextreme-vue': { main: 'index.js', }, 'devextreme': { defaultExtension: 'js', }, 'devextreme/events/utils': { main: 'index', }, 'devextreme/events': { main: 'index', }, 'es6-object-assign': { main: './index.js', defaultExtension: 'js', }, }, packageConfigPaths: [ 'npm:@devextreme/*/package.json', 'npm:@devextreme/runtime@3.0.13/inferno/package.json', ], babelOptions: { sourceMaps: false, stage0: true, }, }; System.config(window.config);
export const dataSource = [{ arg: 'December', day: 7, night: 3, }, { arg: 'January', day: 6, night: 2, }, { arg: 'February', day: 7, night: 3, }, { arg: 'March', day: 10, night: 3, }, { arg: 'April', day: 14, night: 5, }, { arg: 'May', day: 18, night: 8, }, { arg: 'June', day: 21, night: 11, }, { arg: 'July', day: 22, night: 13, }, { arg: 'August', day: 21, night: 13, }, { arg: 'September', day: 19, night: 11, }, { arg: 'October', day: 15, night: 8, }, { arg: 'November', day: 10, night: 4, }]; export const maxDay = dataSource .reduce((prev, current) => (prev.day >= current.day ? prev : current)); export const minNight = dataSource .reduce((prev, current) => (prev.day <= current.day ? prev : current));
import { createApp } from 'vue'; import App from './App.vue'; createApp(App).mount('#app');
<!DOCTYPE html> <html lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.1.6/css/dx.light.css" /> <script src="https://unpkg.com/typescript@4.9.5/lib/typescript.js"></script> <script type="module"> import * as vueCompilerSFC from "https://unpkg.com/@vue/compiler-sfc@3.4.16/dist/compiler-sfc.esm-browser.js"; window.vueCompilerSFC = vueCompilerSFC; </script> <script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script> <script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script> <script type="text/javascript" src="config.js"></script> <script type="text/javascript"> System.import("./index.ts"); </script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="app"> </div> </div> </body> </html>

You can place annotations at specific coordinates or anchor them to PolarChart elements. This demo illustrates the following annotation placement methods:

For more information on annotation settings, refer to the annotations[] help topic.